<?php

namespace saul\UsoSueloBundle\Repository;

/**
 * Pot2Ciiu
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class Pot2CiiuRepository extends \Doctrine\ORM\EntityRepository {

    function consultarActividades($currentPage, $numPerPage, $orderBy, $dataArray) {

	$em = $this->getEntityManager();
	$arrayColumns = [
	    'codCiiu' => ' p2cii.codigo',
	    'nombreCiiu' => ' p2cii.nombre'
	];

	$dqlSelect = "SELECT          
			p2cii.idciiu,
                        concat(p2cii.codigo,' ') as codCiiu,
			p2cii.nombre as nombreCiiu,
			p2cii.palabra_clave as palabraClave
			";
	$dqlSelectCount = "SELECT count(p2resp) ";
	$dqlFrom = "FROM UsoSueloBundle:Pot2Ciiu p2cii
                    WHERE 1 = 1";

	foreach ($dataArray as $key => $value) {
	    if (is_bool($value) || is_numeric($value)) {
		$dqlFrom .= " AND " . $arrayColumns[$key] . "='$value'";
	    } else {
		$dqlFrom .= " AND " . $arrayColumns[$key] . " LIKE '%$value%'";
	    }
	}
	$dqlFrom .= " GROUP BY p2cii.codigo,p2cii.nombre,p2cii.palabra_clave ORDER BY " . $arrayColumns[$orderBy] . " ASC";

	$query = $em->createQuery($dqlSelect . $dqlFrom)
		->setMaxResults($numPerPage)
		->setFirstResult($numPerPage * ($currentPage - 1));
	$queryCount = $em->createQuery($dqlSelectCount . $dqlFrom);
	$result = $query->getResult();

	return ['data' => $result];
    }

}